#INCLUDE "dcdialog.CH"
#INCLUDE "xbppack2.CH"

FUNCTION Main()

LOCAL GetList[0]

@ 0,0 DCPUSHBUTTON CAPTION 'Standard Please Wait Progress Bar' ;
      SIZE 40,2 ACTION {||PleaseWait( 5 )}

@ 2,0 DCPUSHBUTTON CAPTION 'Backup Files Progress Bar' ;
      SIZE 40,2 ACTION {||Backup(.f.)}

@ 4,0 DCPUSHBUTTON CAPTION 'Backup Files Progress Bar (w/cancel button)' ;
      SIZE 40,2 ACTION {||Backup(.t.)}

DCREAD GUI FIT TITLE 'Progress Bars' SETAPPWINDOW

RETURN nil

* -------------

FUNCTION PleaseWait( nSeconds )

LOCAL oProgress, i

DEFAULT nSeconds := 2

oProgress := WaitProgress():new()
oProgress:messageString := 'Doing some stuff. Please Wait...'
oProgress:title := 'Doing Stuff'
oProgress:progressStyle := XBPPRGR_STYLE_MARQUEE
oProgress:create()
FOR i := 1 TO nSeconds * 10
  DC_CompleteEvents() // need this to move window
  Sleep(10)
NEXT
oProgress:destroy()

RETURN nil

* -------------

FUNCTION Backup( lCancelButton )

LOCAL oProgress, aDir, i, j

DEFAULT lCancelButton := .f.

oProgress := WaitProgress():new()
oProgress:messageString := 'Backing up files. Please Wait...'
oProgress:title := 'File Backup'
oProgress:isCancelButton := lCancelButton

oProgress:create()

aDir := Directory()
FOR i := 1 TO Len(aDir)
  oProgress:setData(0)
  oProgress:statusObject:setCaption(aDir[i,1])
  oProgress:progressObject:maximum := aDir[i,2]
  FOR j := 1 TO aDir[i,2] STEP 200 // need this to move window
    oProgress:setData( j )
    DC_CompleteEvents()
    IF oProgress:isCancelled
      EXIT
    ENDIF
  NEXT
  IF oProgress:isCancelled
    EXIT
  ENDIF
NEXT

oProgress:destroy()

RETURN nil

* -----------

CLASS WaitProgress

EXPORTED:

VAR messageObject
VAR messageString
VAR messageFont
VAR statusObject
VAR statusString
VAR statusFont
VAR threadObject
VAR threadInterval
VAR isCancelled
VAR isComplete
VAR getList
VAR evalBlock
VAR progressStaticObject
VAR progressObject
VAR progressInterval
VAR progressStyle
VAR progressMinimum
VAR progressMaximum
VAR progressWidth
VAR progressHeight
VAR progressPause
VAR progressError
VAR title
VAR dialogWindow
VAR isCancelButton

METHOD Init, Create, Destroy, Start, Interval, SetData

ENDCLASS

* ----------

METHOD WaitProgress:Init()

::messageString := 'Please wait...'
::messageFont := '10.Lucida Console'
::statusString := ''
::statusFont := '10.Lucida Console'
::isCancelled := .f.
::isComplete := .f.
::progressWidth := 350
::progressMinimum := 0
::progressMaximum := 200
::progressStyle := XBPPRGR_STYLE_SMOOTH
::progressPause :=  0
::progressError :=  0
::threadInterval := nil
::isCancelButton := .f.

RETURN self

* ----------

METHOD WaitProgress:Create()

LOCAL GetList[0], GetOptions

::getList := GetList

@ 0,0 DCSAY ::messageString SAYSIZE 0 FONT ::messageFont

@ 20,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT SIZE ::progressWidth, 20 COLOR nil, GRA_CLR_WHITE ;
      OBJECT ::progressStaticObject

@ 40,0 DCSAY ::statusString SAYSIZE ::progressWidth, 20 FONT ::statusFont OBJECT ::statusObject

IF ::isCancelButton

  @ 60,0 DCPUSHBUTTON CAPTION {||IIF(::isComplete,'Exit','Cancel')} SIZE 60,20 ;
        ACTION {||::isCancelled := .t., DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

ENDIF

DCGETOPTIONS PIXEL

DCREAD GUI FIT EXIT TITLE ::title EVAL {|o|::dialogWindow := o} ;
   OPTIONS GetOptions MODAL

::Start()

RETURN self

* -----------

METHOD WaitProgress:destroy()

::threadObject:SetInterval( nil )
::dialogWindow:destroy()

RETURN self

* -----------

METHOD WaitProgress:Start()

LOCAL oThread

IF !IsFunction("XbpProgressBar")
  DllLoad('xbppack2.dll')
ENDIF
::progressObject := &('XbpProgressBar()')
::progressObject := ::progressObject:New( ::progressStaticObject,, {0,0}, ::progressStaticObject:currentSize() )
::progressObject:UseVisualStyle := .t.
::progressObject:Create()

::progressObject:Minimum := ::progressMinimum
::progressObject:Maximum := ::progressMaximum
::progressObject:Style   := ::progressStyle

::progressObject:SetData( 0 )

::threadObject := Thread():New()
::threadObject:SetInterval( ::threadInterval )
::threadObject:Start( {|| ::Interval()} )

RETURN .t.

* ---------

METHOD WaitProgress:Interval()

LOCAL nValue := ::progressObject:GetData()

nValue++

IF nValue >= ::progressObject:Maximum
   nValue := ::progressObject:Minimum
   ::progressObject:State := XBPPRGR_STATE_NORMAL
ELSE
   IF nValue > ::progressPause
      ::progressObject:State := XBPPRGR_STATE_PAUSED
   ELSEIF nValue > ::progressError
      ::progressObject:State := XBPPRGR_STATE_ERROR
   ENDIF
ENDIF

::progressObject:SetData( nValue )

RETURN

* ----------

METHOD WaitProgress:setData( nValue )

RETURN ::progressObject:setData( nValue )

* ----------

PROCEDURE AppSys() ; RETURN

